unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, StdCtrls, ColorGrd, Spin, ClipBrd, IniFiles;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    N7: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    Memo1: TMemo;
    ColorDialog1: TColorDialog;
    Close1: TMenuItem;
    Panel2: TPanel;
    procedure Exit1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Panel1Click(Sender: TObject);
    procedure Panel2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure OpenForm;
    procedure ShutForm;
    procedure CheckSave;
    procedure FillForm (n:integer; C:TColor);
    function ColorToRGBCode (c:TColor):String;
  public
    CurrentFileName:String;
  end;

var Form1: TForm1;
var Color1, Color2, C : TColor; {}
  f:TextFile; {}
var Saved: boolean; { }
var s:String;

implementation
uses About;

{$R *.DFM}

procedure TForm1.OpenForm; {  }
begin
 Save1.Enabled:=TRUE;
 SaveAs1.Enabled:=TRUE;
 Close1.Enabled:=True;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 CurrentFileName:='';
 Color1 := $00000000;
 Color2 := $00FFFFFF;
 Panel1.Color:=Color1;
 Panel2.Color:=Color2;
 SaveDialog1.InitialDir := ExtractFilePath(ParamStr(0));
 Saved:=True;

end;

procedure TForm1.ShutForm; {  }
begin
 Save1.Enabled:=False;
 SaveAs1.Enabled:=False;
 Close1.Enabled:=False;
 Memo1.Lines.Clear;
 FormCreate(self);
end;

procedure TForm1.CheckSave;
{ }
var SaveQuest:String; {   }
begin
 if not Saved then begin
  SaveQuest:='   ' + chr (13) +
   chr(10) + CurrentFileName + '?';
  if Application.MessageBox (PChar(SaveQuest),'!',MB_YESNO)=IDYES then
   Save1Click(Form1);
 end;
end;

procedure TForm1.Save1Click(Sender: TObject);
var ext:String;
    f: TextFile;
    i:integer;
begin
 {    '...'}
 if CurrentFileName='' then SaveAs1Click(Form1)
 else begin
  ext:=ExtractFileExt (CurrentFileName);
  if ext<>'.html' then CurrentFileName:=ChangeFileExt (CurrentFileName,'.html');
  assignfile(f,CurrentFileName);
  {$I-}rewrite(f);{I+}
  if IOResult=0 then begin
   Writeln (f,'<HTML>' + chr (13) + chr (10) +
              '<HEAD>' + chr (13) + chr (10) +
              '<TITLE>  '+ColorToRGBCode (Color1)+' '+
               ColorToRGBCode (Color2)+'</TITLE>' + chr (13) + chr (10) +
              '</HEAD>' + chr (13) + chr (10) +
              '<BODY>' + chr (13) + chr (10) +
              '<table border="0" cellpadding="4" cellspacing="0" width="100%" height="50%" align="center">' + chr (13) + chr (10) +
              '<tr><td width="50%" style="background-color: '+ColorToRGBCode (Color1)+'" nowrap>&nbsp;</td>' + chr (13) + chr (10) +
              '    <td width="50%" style="background-color: '+ColorToRGBCode (Color2)+'" nowrap>&nbsp;</td></tr>' + chr (13) + chr (10) +
              '</table>'
   );
   if Memo1.Lines.Count>0 then begin
    Writeln (f,'<PRE>');
    for i:=0 to Memo1.Lines.Count do Writeln (f, Memo1.Lines[i]);
    Writeln (f,'</PRE>');
   end;
   Writeln (f,'</BODY>' + chr (13) + chr (10) + '</HTML>' );
   CloseFile (f);
   Saved:=True;
  end
  else begin
   ShowMessage ('   !      ');
   Saved:=False;
  end;
 end;
end;

procedure TForm1.SaveAs1Click(Sender: TObject);
var Ext:String;
begin
 SaveDialog1.FileName:=CurrentFileName;
 if SaveDialog1.Execute then begin
  CurrentFileName:=SaveDialog1.FileName;
  Save1Click(Form1);
 end;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin //  
 CheckSave;
 Saved:=True;
 ShutForm;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 CheckSave;
 Close;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 Close1Click (Form1);
end;

procedure TForm1.About1Click(Sender: TObject);
begin //   
 with TAboutBox.Create(Self) do
 try
   ShowModal;
 finally
   Free;
 end;
end;

procedure TForm1.Panel1Click(Sender: TObject);
begin
 ColorDialog1.Color:=Color1;
 if ColorDialog1.Execute then begin
  FillForm (1,ColorDialog1.Color);
 end;
end;

procedure TForm1.Panel2Click(Sender: TObject);
begin
 ColorDialog1.Color:=Color2;
 if ColorDialog1.Execute then begin
  FillForm (2,ColorDialog1.Color);
 end;
end;

procedure ColorToRGBCodes (c:TColor; var r,g,b:Byte);
var Color: Longint;
begin
 Color := ColorToRGB(c);
 r := Color;
 g := Color shr 8;
 b := Color shr 16;
end;

function TForm1.ColorToRGBCode (c:TColor):String;
var r, g, b: Byte;
begin
 ColorToRGBCodes (c,r,g,b);
 ColorToRGBCode :=  '#' + IntToHex(r,2) +IntToHex(g,2) + IntToHex(b,2);
end;

function ColorToRGBString (c:TColor):String;
var r, g, b: Byte;
begin
 ColorToRGBCodes (c,r,g,b);
 ColorToRGBString := '#' + IntToHex(r,2) +IntToHex(g,2) + IntToHex(b,2) +
  ' ('+IntToStr(r)+','+IntToStr(g)+','+IntToStr(b)+')'
 ;
end;

function ColorDifference (Color1,Color2:TColor):String;
var r1, g1, b1, r2, g2, b2: Byte;
    d: longint;
    p: real;
begin
 ColorToRGBCodes (Color1,r1,g1,b1);
 ColorToRGBCodes (Color2,r2,g2,b2);
 d := 30*Sqr(R1-R2)+59*Sqr(G1-G2)+11*Sqr(B1-B2); {6502500=max diff.}
 p := d/6502500*100;
 ColorDifference := IntToStr (d)+' ('+FloatToStrF(p,ffFixed,15,2)+'%)';
end;

procedure TForm1.FillForm (n:integer; C:TColor); //   
begin
  if n=1 then begin
   Panel1.Color:=C;
   Color1:=C;
  end
  else begin
   Panel2.Color:=C;
   Color2:=C;
  end;
  Memo1.Lines.Clear;
  Memo1.Lines.Add (' 1:  '+ColorToRGBString (Color1));
  Memo1.Lines.Add (' 2:  '+ColorToRGBString (Color2));
  Memo1.Lines.Add (': '+ColorDifference (Color1,Color2));
  OpenForm;
  Saved:=False;
end;

end.

